/***********************************************************************
**
** Module:		desktop.cpp
**
** Description:	This module implements our desktop
**
** Author:		Geoffrey J. Elliott (GeoffE)
**
** Created:		02/26/99
**
** Modified:	
**
**				Copyright (C) 1999 Geoffrey J. Elliott
**				All Rights Reserved
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
** 
** The author can be contacted via Email at geo@cybersnot.com
**
***********************************************************************/


//======================================================================
//
// CDesktop
//
// This class implements our desktop window.
//
class CDesktopService : public IShellWindow,
						public IShellService
						
{
private:
	HWND		m_hwnd;
	HINSTANCE	m_hInst;
	HWND		m_hwndParent;

	UINT		m_screenWidth;
	UINT		m_screenHeight;

	//
	// Window event handlers:
	//
	LRESULT		_wmActivate(VOID);
	LRESULT		_wmDisplayChange(UINT screenWidth, UINT screenHeight);
	LRESULT		_wmEndSession(VOID);
	LRESULT		_wmEraseBackground(HDC hdc);
	LRESULT		_wmMouseActivate(VOID);
	LRESULT		_wmNCPaint(HRGN hrgn);
	LRESULT		_wmNotifyParent(UINT uMsg, WPARAM wParam, LPARAM lParam);
	LRESULT		_wmPaint(VOID);
	LRESULT		_wmRButtonUp(INT x, INT y);
	LRESULT		_wmWindowPosChanging(WINDOWPOS *wpPosition);

public:
					CDesktopService();
					~CDesktopService();

		//
		// IShellService Methods
		//
virtual	HRESULT		Startup(HINSTANCE hInst, HWND hwndParent);
virtual HRESULT		Shutdown(VOID);

		//
		// IShellWindow Methods:
		//
virtual HWND		Hwnd(VOID);
virtual LRESULT		wndProc(HWND hwnd, UINT uMsg, WPARAM wPAram, LPARAM lParam);
virtual LRESULT	SendMessage(UINT uMsg, WPARAM wParam, LPARAM lParam);
virtual LRESULT	PostMessage(UINT uMsg, WPARAM wParam, LPARAM lParam);

//////////////////////////////////////////////////////////////////
// Added by SamIam
// Sets the size of the desktop 
//
protected:
	void SetDesktopArea(int left, int top, int right, int bottom);
	void setMinMax(void);
	void resetMinMax(void);
//
// End Added by SamIam
///////////////////////////////////////////////////////////////////////
};


extern CDesktopService *g_desktopService;